# Predator Prey Cellular Automaton
# Suharsh Sivakumar
# December 8, 2010


from OpenGL.GL import *
from OpenGL.GLU import *
from OpenGL.GLUT import *
from numpy import *
import sys
from random import *


#  Set the global width, height, and axis ranges of the window
global width
global height
global axrng
global column
global cells
global interval
global c
global newc


sleep = 1
global ii  #generation counter

#  Initial values
width = 700
height = 700
axrng = 125
column = 125
cells = column*column
interval = axrng/column


ii=0


c =  [0]*2*cells
newc =  [0]*2*cells

def initFrustum():
  # White background
  glClearColor(0.0, 0.0, 0.0, 0.0)
  gluOrtho2D(0, axrng, 0, axrng)

def display():

  glClear(GL_COLOR_BUFFER_BIT)
  glPointSize(width/column - 1)
  glBegin(GL_POINTS)
  for n in range(0,cells):
    #predator
    if c[n] == 0:
      glColor3f(1.0, 0.0, 0.0)
    #prey  
    if c[n] == 1:
      glColor3f(0.0, 1.0, 0.0)
    #empty  
    if c[n] == 2:
      glColor3f(0.0, 0.0, 0.0)
    rowindex = n/column
    colindex = n - rowindex*column   
    glVertex2f(colindex*interval + interval/2, rowindex*interval + interval/2)

  glEnd()
  glFlush()

def initial():
  global ii 
  #where we start
  if ii < 1:
   for n in range(0,cells):
    v = random()

    if v < .3:
      c[n] = 0

    if .3 < v < .75:
      c[n] = 1

    if v >.75:
      c[n] = 2
   print "generation 0"  
 
  
def generations():
  global ii

  prednum = 0.0
  preynum = 0.0

  for n in range(0,cells):
      #count total number of predators and prey
      if c[n] == 0:
        prednum = prednum + 1.0
      elif c[n] == 1:
        preynum = preynum + 1.0

      #identify neighbors
      if (n+1) == cells:
        rightcell = 0
      else:
        rightcell = (n+1)
      if (n-1) < 0:
        leftcell = (cells-1)
      else:
        leftcell = (n-1)
      if (n + column) >= cells:
        bottomcell = (n-cells+column)
      else:
        bottomcell = (n + column)
      if (n - column) < 0:
        topcell = (cells - column +n)
      else:
        topcell = (n - column)
      if (n+column+1) >= cells:
        bottomrightcell = (n-cells+column+1)
      else:
        bottomrightcell = (n + column +1)
      if (n - column + 1) < 0:
        toprightcell = (cells - column + n + 1)
      else:
        toprightcell = (n - column +1)
      if (n+column-1) >= cells:
        bottomleftcell = (n-cells+column-1)
      else:
        bottomleftcell = (n + column -1)
      if (n - column - 1) < 0:
        topleftcell = (cells - column + n - 1)
      else:
        topleftcell = (n - column -1)
      #calculate prey and pred count
      predcount = 0
      preycount = 0
      if c[rightcell] == 0:
        predcount = predcount + 1
      elif c[rightcell] == 1:
        preycount = preycount + 1
      if c[leftcell] == 0:
        predcount = predcount + 1
      elif c[leftcell] == 1:
        preycount = preycount + 1
      if c[topcell] == 0:
        predcount = predcount + 1
      elif c[topcell] == 1:
        preycount = preycount + 1
      if c[bottomcell] == 0:
        predcount = predcount + 1
      elif c[bottomcell] == 1:
        preycount = preycount + 1
      if c[bottomrightcell] == 0:
        predcount = predcount + 1
      elif c[bottomrightcell] == 1:
        preycount = preycount + 1
      if c[bottomleftcell] == 0:
        predcount = predcount + 1
      elif c[bottomleftcell] == 1:
        preycount = preycount + 1
      if c[topleftcell] == 0:
        predcount = predcount + 1
      elif c[topleftcell] == 1:
        preycount = preycount + 1
      if c[toprightcell] == 0:
        predcount = predcount + 1
      elif c[toprightcell] == 1:
        preycount = preycount + 1
      # Automaton rules
      # Predator cell rule
      if c[n] == 0: 
        if preycount > 1:
          newc[n] = 0
        else:
          newc[n] = 2
      # prey cell rule  
      elif c[n] == 1:
        if 5 > predcount > 0:
          newc[n] = 2
        elif predcount > 4:
          newc[n] = 0
        else:
          newc[n] = 1
      # empty cell rule
      elif c[n] == 2:
        if preycount > predcount:
          newc[n] = 1
        elif predcount > preycount-1:
          if preycount > 0:
            newc[n] = 0
          else:
            newc[n] = 2
        else:
          newc[n] = 2
  ii = ii+1  #new generation is complete      
  print "generation", (ii) 
  print "Number of Predators is", prednum
  print "Number of Prey is", preynum
  print "Ratio of Prey to Predators is", preynum/prednum
    #Copying new generation to old generation
  for n in range (0, cells):
      c[n]=newc[n]

        
def full():
  initial()
  display()
  generations()      

def keyboard(key, x, y):
   if key == chr(27) or key == 'q':
     sys.exit(0)
   glutPostRedisplay()

def Timer(extra):
  glutPostRedisplay()
  glutTimerFunc(sleep,Timer,0)



     
	
def main():
  
  glutInit(sys.argv)
  glutInitDisplayMode(GLUT_RGB|GLUT_SINGLE)
  glutInitWindowSize(width,height)
  glutInitWindowPosition(50,50)
  glutCreateWindow("Predator Prey Cellular Automaton")
  glutDisplayFunc(full)
  glutKeyboardFunc(keyboard)
  glutTimerFunc(0,Timer,0)
  initFrustum()
  glutMainLoop()
  
main()
